package com.goafanti.common.dao;

import com.goafanti.common.model.UserFirstInterview;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 客户首次面谈表(UserFirstInterview)表数据库访问层
 *
 * @author makejava
 * @since 2025-04-11 14:04:36
 */
public interface UserFirstInterviewMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    UserFirstInterview selectById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param userFirstInterview 查询条件
     * @param pageable           分页对象
     * @return 对象列表
     */
    List<UserFirstInterview> findUserFirstInterviewList(UserFirstInterview userFirstInterview, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param userFirstInterview 查询条件
     * @return 总行数
     */
    int findUserFirstInterviewCount(UserFirstInterview userFirstInterview);

    /**
     * 新增数据
     *
     * @param userFirstInterview 实例对象
     * @return 影响行数
     */
    int insert(UserFirstInterview userFirstInterview);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserFirstInterview> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<UserFirstInterview> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<UserFirstInterview> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<UserFirstInterview> entities);

    /**
     * 修改数据
     *
     * @param userFirstInterview 实例对象
     * @return 影响行数
     */
    int update(UserFirstInterview userFirstInterview);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<UserFirstInterview> selectByUidAid(@Param("uid") String uid, @Param("aid") String aid);

    void deleteByPrdId(Integer id);
}

